package com.objis.gestionformations.dao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.List;

import com.objis.gestionformations.domaine.Utilisateur;


public class UtilisateurDao
{

	// Etape 1 : permettre  la couche service d'instancier cette dao

	// Etape 2 : mettre un CRUD + getAll dans la DAO

	// Avant tout !! modifier les paramtres de la classe Utilisateur
	// Crer les methodes CRUD + get All
	// Instanciations
	

	// les mthodes
	
	
	
	// la mthode create va instancier un nouvel utilisateur et ne renvoie rien : juste insertion dans la base de donnes
	public void createUser(Utilisateur utilisateur)
	{
		// information  la base de donnes
				String url = "jdbc:mysql://localhost/formation";
				String loginD = "root";
				String passwd = "";
				Connection cn = null;
				PreparedStatement pstmt = null;
				String sql = null;
				

				try
				{
					// Etape 1 : Chargement du driver
					Class.forName("com.mysql.jdbc.Driver");

					// Etape 2: rcupration de la connexion
					cn = DriverManager.getConnection(url, loginD, passwd);

					// Etape 3 : Creation de la requte
					pstmt = cn.prepareStatement("INSERT INTO utilisateurs VALUES (?,?,?,?,?,?)");

					// Etape 4 : renseignement des champs  remplir pr la requte
					pstmt.setString(1,utilisateur.getLogin());
					pstmt.setString(2,utilisateur.getPwd());
					pstmt.setString(3,utilisateur.getNom());
					pstmt.setString(4,utilisateur.getPrenom());
					pstmt.setString(5,utilisateur.getEmail());
					pstmt.setString(6,utilisateur.getAdresse());
					
					// Etape 5 : excution requte
					pstmt.executeUpdate();
			
					}
				catch (SQLException e)
				{
					e.printStackTrace();
				} catch (ClassNotFoundException e)
				{
					e.printStackTrace();
				} finally
				{
					try
					{

						// Etape 6 : librer ressources de la mmoire.
						cn.close();
						
					} catch (SQLException e)
					{
						e.printStackTrace();
					}
				}		
		System.out.println("Un nouvel utilisateur a t cre.");
	}

	
	
	// methode qui manipule un login et qui retourne un utilisateur
	public Utilisateur getUserByLogin(String login)
	{

		// information  la base de donnes
		String url = "jdbc:mysql://localhost/formation";
		String loginD = "root";
		String passwd = "";
		Connection cn = null;
		Statement st = null;
		ResultSet rs = null;
		Utilisateur utilisateur = new Utilisateur();

		try
		{
			// Etape 1 : Chargement du driver
			Class.forName("com.mysql.jdbc.Driver");

			// Etape 2: rcupration de la connexion
			cn = DriverManager.getConnection(url, loginD, passwd);

			// Etape 3 : Creation d'un statement
			st = cn.createStatement();
			String sql = "SELECT * FROM utilisateurs";

			// Etape 4 : excution requte
			rs = st.executeQuery(sql);

			// si rcup donnes alors Etape 5 : ResultSet
			// il faut mettre  jour l'objet utilisateur qui est en retour :
			// grce  la mthode set qui prend en charge le rsultat de la
			// requte sql
			while (rs.next())
			{ utilisateur.setLogin(rs.getString("Login"));
				utilisateur.setPwd(rs.getString("Password"));
				utilisateur.setNom(rs.getString("Nom"));
				utilisateur.setPrenom(rs.getString("Prenom"));
				utilisateur.setAdresse(rs.getString("Adresse"));
				utilisateur.setEmail(rs.getString("Email"));
			}
		} catch (SQLException e)
		{
			e.printStackTrace();
		} catch (ClassNotFoundException e)
		{
			e.printStackTrace();
		} finally
		{
			try
			{

				// Etape 6 : librer ressources de la mmoire.
				cn.close();
				st.close();
			} catch (SQLException e)
			{
				e.printStackTrace();
			}
		}

		System.out.println("Information utilisateur");
		
		return utilisateur;

	}

	public void upDateUser(Utilisateur utilisateur)
	{
		System.out.println("Des changements ont t fait.");
	}

	public void deleteUser(Utilisateur utilisateur)
	{
		System.out.println("Un utilisateur a t supprim.");
	}

	public List<Utilisateur> getAllUser()
	{
		System.out.println("La liste des utilisateurs est : ");
		return null;
		// retourne la collection ou liste des Utilisateurs
	}

}
